/*!
 * vue-auth-msal v1.0.1
 * (c) 2023 Shige Fukushima <shigeyf@outlook.com>
 * @license Apache-2.0
 */
var VueAuthMsal=function(e,t,n){"use strict";const s="vue-auth-msal",i="1.0.1",o=Symbol(),a=Symbol();function r(e,n){const s=n.getLogger();e.beforeEach((async(e,i)=>{s.verbose("vue-router:beforeEach():Called"),s.verbose("vue-router:beforeEach():Awaiting MsalPlugin Init"),await n.waitInitPromise,s.verbose("vue-router:beforeEach():Finished MsalPlugin Init");let o=!0;if(n.getCurrentInteractionStaus()===t.InteractionStatus.HandleRedirect){const t=e.fullPath.split("#")[0];e.fullPath=t,e.hash=""}if(e.matched.some((e=>e.meta.requiresAuth))){s.verbose("vue-router:beforeEach():Invoke RouterGuard for MsalPlugin because of 'requiresAuth' = true");const i={...n.options.loginRequest,redirectStartPage:e.fullPath};o=await async function(e,n,s){return e.handleRedirectPromise().then((()=>e.getAllAccounts().length>0||(n===t.InteractionType.Popup?e.loginPopup(s).then((()=>!0)).catch((()=>!1)):n===t.InteractionType.Redirect&&e.loginRedirect(s).then((()=>!0)).catch((()=>!1))))).catch((()=>!1))}(n.instance,n.options.interactionType,i)}return s.verbose("vue-router:beforeEach():Returned"),o}))}class l extends t.NavigationClient{router;pca;constructor(e,t){super(),this.router=e,this.pca=t}async navigateInternal(e,t){this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Called"),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():url = ${e}`),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():options = ${JSON.stringify(t)}`);const n=e.replace(window.location.origin,"");return t.noHistory?this.router.replace(n):this.router.push(n),this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Returned always false"),!1}}class c{instance;options;_state;_logger;_eventCallbacks;_initResolver;waitInitPromise;constructor(e){this.options={interactionType:t.InteractionType.Redirect,loginRequest:{scopes:[]}},this.instance=new t.PublicClientApplication(e.configuration),null!=e.interactionType&&(this.options.interactionType=e.interactionType),null!=e.loginRequest&&(this.options.loginRequest=e.loginRequest),this._state=n.reactive({inProgress:t.InteractionStatus.None,activeAccount:this.instance.getActiveAccount(),accounts:this.instance.getAllAccounts()}),this._initResolver=null,this.waitInitPromise=Promise.resolve(),this.instance.initializeWrapperLibrary(s,i),this._logger=this.instance.getLogger().clone(s,i),this._eventCallbacks=[]}getLogger(){return this._logger}getCurrentInteractionStaus(){return this._state.inProgress}async install(e,n){if(this._logger.verbose("MsalPlugin:install():Called"),null!=n.router){this._logger.verbose("MsalPlugin:install:Initialize Router extension");const e=new l(n.router,this.instance);this.instance.setNavigationClient(e),r(n.router,this)}this._logger.verbose("MsalPlugin:install:Initialize MsalState"),e.provide(o,this),e.provide(a,this._state),this._logger.verbose("MsalPlugin:install:Initialize Event Callback Hooks");let s=null;s=this.instance.addEventCallback((e=>{this._logger.verbose(`MsalPlugin:install:EventCallback:[ForDebug]:EventType: ${e.eventType}`)})),this._eventCallbacks.push({name:"ForDebug",id:s}),s=this.instance.addEventCallback((e=>{if(e.eventType===t.EventType.LOGIN_SUCCESS){if(this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Called"),e.payload){const t=e.payload;this._logger.verbose(`MsalPlugin:install:EventCallback:[LoginSuccess]:Payload: ${JSON.stringify(t)}`),null!=t.account&&this.setNewActiveAccount(t.account)}this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Returned")}})),this._eventCallbacks.push({name:"LoginSuccess",id:s}),s=this.instance.addEventCallback((e=>{switch(e.eventType){case t.EventType.LOGOUT_END:case t.EventType.ACCOUNT_ADDED:case t.EventType.ACCOUNT_REMOVED:case t.EventType.LOGIN_SUCCESS:case t.EventType.LOGIN_FAILURE:case t.EventType.SSO_SILENT_SUCCESS:case t.EventType.SSO_SILENT_FAILURE:case t.EventType.ACQUIRE_TOKEN_SUCCESS:case t.EventType.ACQUIRE_TOKEN_FAILURE:case t.EventType.HANDLE_REDIRECT_END:this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Called"),this.updateAccounts(),e.eventType===t.EventType.LOGOUT_END&&this.resetAccount(),this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Returned")}})),this._eventCallbacks.push({name:"AccountsUpdate",id:s}),s=this.instance.addEventCallback((e=>{this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Called"),this.updateStatusByMessage(e),this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Returned")})),this._eventCallbacks.push({name:"StatusUpdate",id:s}),s=this.instance.addEventCallback((e=>{if(e.eventType===t.EventType.LOGOUT_END&&e.interactionType===t.InteractionType.Popup){this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Called");const e=n.router;if(null!=e){const t=e.currentRoute.value;t.meta.requiresAuth&&null!=t.meta.popupLogoutFallback&&(this._logger.info(`MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Route to: ${t.meta.popupLogoutFallback}`),e.push(t.meta.popupLogoutFallback))}this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Returned")}})),this._eventCallbacks.push({name:"LogOutPopupEnd",id:s}),this.waitInit(),await this.instance.initialize().then((()=>{this._logger.verbose("MsalPlugin:install:instance.initialize finished"),this.instance.handleRedirectPromise().then((e=>{null!=e?(this._logger.verbose(`MsalPlugin:install:handleRedirectPromise success response: ${JSON.stringify(e)}`),null!=e.account&&this.setNewActiveAccount(e.account)):(this._logger.verbose("MsalPlugin:install:handleRedirectPromise success response: null"),this.resetAccount(),this.updateAccounts())})).catch((e=>{this._logger.error(`MsalPlugin:install:handleRedirectPromise error: ${e}`)})).finally((()=>{this._logger.verbose("MsalPlugin:install:handleRedirectPromise:finally:Called"),this.resetInProgress()}))})),this.doneInit(),this._logger.verbose("MsalPlugin:install():Returned")}updateStatusByMessage(e){const n=this._state.inProgress,s=t.EventMessageUtils.getInteractionStatusFromEvent(e,this._state.inProgress);null!==s&&(this._state.inProgress=s,this._logger.info(`MsalPlugin:updateStatusByMessage:Updated from ${n} to ${s}`))}resetInProgress(){this._state.inProgress=t.InteractionStatus.None,this._logger.info("MsalPlugin:resetInProgress: inProgress to none")}updateAccounts(){const e=this.instance.getAllAccounts();(function(e,t){if(e.length!==t.length)return!1;const n=[...t];return e.every((e=>{const t=n.shift();return!(!e||!t)&&e.homeAccountId===t.homeAccountId&&e.localAccountId===t.localAccountId&&e.username===t.username}))})(e,this._state.accounts)||(this._state.accounts=e,this._logger.info(`MsalPlugin:updateAccounts:Updated to: ${JSON.stringify(this._state.accounts)}`))}setNewActiveAccount(e){this.instance.setActiveAccount(e),this._state.activeAccount=this.instance.getActiveAccount(),this._logger.info(`MsalPlugin:setNewActiveAccount: ${e.username}`)}resetAccount(){const e=this.instance.getAllAccounts();if(0===e.length)this._state.activeAccount=null,this._logger.info("MsalPlugin:resetAccount: null");else if(e.length>0){const e=this._state.accounts[0];this.instance.setActiveAccount(e),this._state.activeAccount=e,this._logger.info(`MsalPlugin:resetAccount: ${e.username}`)}}waitInit(){null==this._initResolver&&(this.waitInitPromise=new Promise((e=>this._initResolver=e)))}doneInit(){null!=this._initResolver&&(this._initResolver(),this._initResolver=null,this.waitInitPromise=Promise.resolve())}}function u(){const e=n.inject(o);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}function g(){const e=u(),s=e.options.interactionType,i=e.options.loginRequest,o=e.getLogger(),r=e.instance,l=function(){const e=n.inject(a);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}(),{inProgress:c,accounts:g,activeAccount:h}=n.toRefs(l);return{instance:r,inProgress:c,account:h,accounts:g,ops:{login:e=>{if(c.value===t.InteractionStatus.None){o.verbose("useMsal.login():Called");const n=null!=e?e:i;s===t.InteractionType.Popup?(o.verbose(`useMsal.login():loginPopup triggered with ${JSON.stringify(n)}`),r.loginPopup(n).catch((e=>{e instanceof t.BrowserAuthError&&e.errorCode===t.BrowserAuthErrorMessage.userCancelledError.code?o.info("useMsal.login():loginPopup user_cancelled"):o.error(`useMsal.login():loginPopup error: ${JSON.stringify(e)}`)}))):s==t.InteractionType.Redirect&&(o.verbose(`useMsal.login():loginRedirect triggered with ${JSON.stringify(n)}`),r.loginRedirect(n)),o.verbose("useMsal.login():Returned")}else o.verbose(`useMsal.login():Blocked due to other process is running (state=${c.value})`)},logout:e=>{if(c.value===t.InteractionStatus.None){o.verbose("useMsal.logout():Called");const n={account:r.getActiveAccount()};if(s===t.InteractionType.Popup){const t=null!=e?e:{mainWindowRedirectUri:"/",...n};o.verbose(`useMsal.logout():logoutPopup triggered with ${JSON.stringify(t)}`),r.logoutPopup(t)}else if(s==t.InteractionType.Redirect){const t=null!=e?e:n;o.verbose(`useMsal.logout():logoutRedirect triggered with ${JSON.stringify(t)}`),r.logoutRedirect(t)}o.verbose("useMsal.logout():Returned")}else o.verbose(`useMsal.logout():Blocked due to other process is running (state=${c.value})`)}}}}return e.MsalPlugin=c,e.createMsal=function(e){return new c(e)},e.pkgBuildDate='"2023-12-15T09:18:01.420Z"',e.pkgName=s,e.pkgVersion=i,e.useAccount=function(){const e=u(),s=e.options.interactionType,i=e.options.loginRequest,o=e.getLogger(),{account:a,instance:r}=g(),l=n.computed((()=>a.value?a.value.username:"(No username)")),c=n.computed((()=>null!=a.value&&null!=a.value.name?a.value.name:"(No name)"));return{account:a,name:c,username:l,switchAccount:async e=>{o.verbose("useAccount.switchAccount():Called");const n={...i,account:e,prompt:"none"};try{o.verbose(`useAccount.switchAccount():ssoClient triggered with: ${JSON.stringify(n)}`),await r.ssoSilent(n).then((e=>{o.verbose(`useAccount.switchAccount():ssoClient:success response: ${JSON.stringify(e)}`),null!=e.account&&(r.setActiveAccount(e.account),a.value=r.getActiveAccount(),o.info(`useAccount.switchAccount():ssoClient set ActiveAccount: ${e.account.username}`))}))}catch(e){if(o.verbose(`useAccount.switchAccount():ssoClient error: ${JSON.stringify(e)}`),e instanceof t.InteractionRequiredAuthError){const e={...n,prompt:"login"};s===t.InteractionType.Popup?r.loginPopup(e).then((e=>{o.verbose(`useAccount.switchAccount():loginPopup:success response: ${JSON.stringify(e)}`),null!=e.account&&(r.setActiveAccount(e.account),a.value=r.getActiveAccount(),o.info(`useAccount.switchAccount():loginPopup set ActiveAccount: ${e.account.username}`))})).catch((e=>{o.verbose(`useAccount.switchAccount():loginPopup error: ${JSON.stringify(e)}`)})):r.loginRedirect(e).catch((e=>{o.verbose(`useAccount.switchAccount():loginRedirect error: ${JSON.stringify(e)}`)}))}}o.verbose("useAccount.switchAccount():Returned")}}},e.useIsAuthenticated=function(){const{accounts:e}=g(),t=n.ref(e.value.length>0);return n.watch(e,(()=>{t.value=e.value.length>0})),t},e.useMsal=g,e.useMsalAuthentication=function(){const e=u(),s=e.options.interactionType,i=e.options.loginRequest,o=e.getLogger(),{instance:a,inProgress:r}=g(),l=s,c=n.ref(!1),h=n.ref(null),v=n.ref(null);return{acquireToken:async e=>{if(o.verbose("useMsalAuthentication.acquireToken():Called"),!c.value){if(c.value=!0,r.value===t.InteractionStatus.HandleRedirect){o.verbose("useMsalAuthentication.acquireToken():handleRedirectPromise triggered");try{const e=await a.handleRedirectPromise();e&&(o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise success response: ${JSON.stringify(e)}`),h.value=e,v.value=null)}catch(e){o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise error: ${JSON.stringify(e)}`),h.value=null,v.value=e}c.value=!1}else if(r.value===t.InteractionStatus.None){const n=e||i;o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent triggered with ${JSON.stringify(n)}`);try{const e=await a.acquireTokenSilent(n);o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent success response: ${JSON.stringify(e)}`),h.value=e,v.value=null}catch(e){o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent error = ${JSON.stringify(e)}`),e instanceof t.InteractionRequiredAuthError||e instanceof t.BrowserAuthError&&e.errorCode===t.BrowserAuthErrorMessage.noAccountError.code&&0==a.getAllAccounts().length?(o.verbose(`useMsalAuthentication.acquireToken():interactive login triggered with ${JSON.stringify(n)}`),l===t.InteractionType.Popup?await a.loginPopup(n).then((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginPopup success response: ${JSON.stringify(e)}`),h.value=e,v.value=null})).catch((e=>{h.value=null,v.value=e,e instanceof t.BrowserAuthError&&e.errorCode===t.BrowserAuthErrorMessage.userCancelledError.code?o.info("useMsal.login():loginPopup user_cancelled"):o.error(`useMsal.login():loginPopup error: ${JSON.stringify(e)}`)})):await a.loginRedirect(n).catch((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginRedirect error: ${JSON.stringify(e)}`),h.value=null,v.value=e}))):(h.value=null,v.value=e)}}c.value=!1}o.verbose("useMsalAuthentication.acquireToken():Returned")},result:h,error:v}},e}({},msalBrowser,Vue);
