/*!
 * vue-auth-msal v1.0.1
 * (c) 2023 Shige Fukushima <shigeyf@outlook.com>
 * @license Apache-2.0
 */
"use strict";var e=require("@azure/msal-browser"),t=require("vue");const n="vue-auth-msal",s="1.0.1",i=Symbol(),o=Symbol();function a(t,n){const s=n.getLogger();t.beforeEach((async(t,i)=>{s.verbose("vue-router:beforeEach():Called"),s.verbose("vue-router:beforeEach():Awaiting MsalPlugin Init"),await n.waitInitPromise,s.verbose("vue-router:beforeEach():Finished MsalPlugin Init");let o=!0;if(n.getCurrentInteractionStaus()===e.InteractionStatus.HandleRedirect){const e=t.fullPath.split("#")[0];t.fullPath=e,t.hash=""}if(t.matched.some((e=>e.meta.requiresAuth))){s.verbose("vue-router:beforeEach():Invoke RouterGuard for MsalPlugin because of 'requiresAuth' = true");const i={...n.options.loginRequest,redirectStartPage:t.fullPath};o=await async function(t,n,s){return t.handleRedirectPromise().then((()=>t.getAllAccounts().length>0||(n===e.InteractionType.Popup?t.loginPopup(s).then((()=>!0)).catch((()=>!1)):n===e.InteractionType.Redirect&&t.loginRedirect(s).then((()=>!0)).catch((()=>!1))))).catch((()=>!1))}(n.instance,n.options.interactionType,i)}return s.verbose("vue-router:beforeEach():Returned"),o}))}class r extends e.NavigationClient{router;pca;constructor(e,t){super(),this.router=e,this.pca=t}async navigateInternal(e,t){this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Called"),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():url = ${e}`),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():options = ${JSON.stringify(t)}`);const n=e.replace(window.location.origin,"");return t.noHistory?this.router.replace(n):this.router.push(n),this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Returned always false"),!1}}class l{instance;options;_state;_logger;_eventCallbacks;_initResolver;waitInitPromise;constructor(i){this.options={interactionType:e.InteractionType.Redirect,loginRequest:{scopes:[]}},this.instance=new e.PublicClientApplication(i.configuration),null!=i.interactionType&&(this.options.interactionType=i.interactionType),null!=i.loginRequest&&(this.options.loginRequest=i.loginRequest),this._state=t.reactive({inProgress:e.InteractionStatus.None,activeAccount:this.instance.getActiveAccount(),accounts:this.instance.getAllAccounts()}),this._initResolver=null,this.waitInitPromise=Promise.resolve(),this.instance.initializeWrapperLibrary(n,s),this._logger=this.instance.getLogger().clone(n,s),this._eventCallbacks=[]}getLogger(){return this._logger}getCurrentInteractionStaus(){return this._state.inProgress}async install(t,n){if(this._logger.verbose("MsalPlugin:install():Called"),null!=n.router){this._logger.verbose("MsalPlugin:install:Initialize Router extension");const e=new r(n.router,this.instance);this.instance.setNavigationClient(e),a(n.router,this)}this._logger.verbose("MsalPlugin:install:Initialize MsalState"),t.provide(i,this),t.provide(o,this._state),this._logger.verbose("MsalPlugin:install:Initialize Event Callback Hooks");let s=null;s=this.instance.addEventCallback((e=>{this._logger.verbose(`MsalPlugin:install:EventCallback:[ForDebug]:EventType: ${e.eventType}`)})),this._eventCallbacks.push({name:"ForDebug",id:s}),s=this.instance.addEventCallback((t=>{if(t.eventType===e.EventType.LOGIN_SUCCESS){if(this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Called"),t.payload){const e=t.payload;this._logger.verbose(`MsalPlugin:install:EventCallback:[LoginSuccess]:Payload: ${JSON.stringify(e)}`),null!=e.account&&this.setNewActiveAccount(e.account)}this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Returned")}})),this._eventCallbacks.push({name:"LoginSuccess",id:s}),s=this.instance.addEventCallback((t=>{switch(t.eventType){case e.EventType.LOGOUT_END:case e.EventType.ACCOUNT_ADDED:case e.EventType.ACCOUNT_REMOVED:case e.EventType.LOGIN_SUCCESS:case e.EventType.LOGIN_FAILURE:case e.EventType.SSO_SILENT_SUCCESS:case e.EventType.SSO_SILENT_FAILURE:case e.EventType.ACQUIRE_TOKEN_SUCCESS:case e.EventType.ACQUIRE_TOKEN_FAILURE:case e.EventType.HANDLE_REDIRECT_END:this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Called"),this.updateAccounts(),t.eventType===e.EventType.LOGOUT_END&&this.resetAccount(),this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Returned")}})),this._eventCallbacks.push({name:"AccountsUpdate",id:s}),s=this.instance.addEventCallback((e=>{this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Called"),this.updateStatusByMessage(e),this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Returned")})),this._eventCallbacks.push({name:"StatusUpdate",id:s}),s=this.instance.addEventCallback((t=>{if(t.eventType===e.EventType.LOGOUT_END&&t.interactionType===e.InteractionType.Popup){this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Called");const e=n.router;if(null!=e){const t=e.currentRoute.value;t.meta.requiresAuth&&null!=t.meta.popupLogoutFallback&&(this._logger.info(`MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Route to: ${t.meta.popupLogoutFallback}`),e.push(t.meta.popupLogoutFallback))}this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Returned")}})),this._eventCallbacks.push({name:"LogOutPopupEnd",id:s}),this.waitInit(),await this.instance.initialize().then((()=>{this._logger.verbose("MsalPlugin:install:instance.initialize finished"),this.instance.handleRedirectPromise().then((e=>{null!=e?(this._logger.verbose(`MsalPlugin:install:handleRedirectPromise success response: ${JSON.stringify(e)}`),null!=e.account&&this.setNewActiveAccount(e.account)):(this._logger.verbose("MsalPlugin:install:handleRedirectPromise success response: null"),this.resetAccount(),this.updateAccounts())})).catch((e=>{this._logger.error(`MsalPlugin:install:handleRedirectPromise error: ${e}`)})).finally((()=>{this._logger.verbose("MsalPlugin:install:handleRedirectPromise:finally:Called"),this.resetInProgress()}))})),this.doneInit(),this._logger.verbose("MsalPlugin:install():Returned")}updateStatusByMessage(t){const n=this._state.inProgress,s=e.EventMessageUtils.getInteractionStatusFromEvent(t,this._state.inProgress);null!==s&&(this._state.inProgress=s,this._logger.info(`MsalPlugin:updateStatusByMessage:Updated from ${n} to ${s}`))}resetInProgress(){this._state.inProgress=e.InteractionStatus.None,this._logger.info("MsalPlugin:resetInProgress: inProgress to none")}updateAccounts(){const e=this.instance.getAllAccounts();(function(e,t){if(e.length!==t.length)return!1;const n=[...t];return e.every((e=>{const t=n.shift();return!(!e||!t)&&e.homeAccountId===t.homeAccountId&&e.localAccountId===t.localAccountId&&e.username===t.username}))})(e,this._state.accounts)||(this._state.accounts=e,this._logger.info(`MsalPlugin:updateAccounts:Updated to: ${JSON.stringify(this._state.accounts)}`))}setNewActiveAccount(e){this.instance.setActiveAccount(e),this._state.activeAccount=this.instance.getActiveAccount(),this._logger.info(`MsalPlugin:setNewActiveAccount: ${e.username}`)}resetAccount(){const e=this.instance.getAllAccounts();if(0===e.length)this._state.activeAccount=null,this._logger.info("MsalPlugin:resetAccount: null");else if(e.length>0){const e=this._state.accounts[0];this.instance.setActiveAccount(e),this._state.activeAccount=e,this._logger.info(`MsalPlugin:resetAccount: ${e.username}`)}}waitInit(){null==this._initResolver&&(this.waitInitPromise=new Promise((e=>this._initResolver=e)))}doneInit(){null!=this._initResolver&&(this._initResolver(),this._initResolver=null,this.waitInitPromise=Promise.resolve())}}function c(){const e=t.inject(i);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}function u(){const n=c(),s=n.options.interactionType,i=n.options.loginRequest,a=n.getLogger(),r=n.instance,l=function(){const e=t.inject(o);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}(),{inProgress:u,accounts:g,activeAccount:h}=t.toRefs(l);return{instance:r,inProgress:u,account:h,accounts:g,ops:{login:t=>{if(u.value===e.InteractionStatus.None){a.verbose("useMsal.login():Called");const n=null!=t?t:i;s===e.InteractionType.Popup?(a.verbose(`useMsal.login():loginPopup triggered with ${JSON.stringify(n)}`),r.loginPopup(n).catch((t=>{t instanceof e.BrowserAuthError&&t.errorCode===e.BrowserAuthErrorMessage.userCancelledError.code?a.info("useMsal.login():loginPopup user_cancelled"):a.error(`useMsal.login():loginPopup error: ${JSON.stringify(t)}`)}))):s==e.InteractionType.Redirect&&(a.verbose(`useMsal.login():loginRedirect triggered with ${JSON.stringify(n)}`),r.loginRedirect(n)),a.verbose("useMsal.login():Returned")}else a.verbose(`useMsal.login():Blocked due to other process is running (state=${u.value})`)},logout:t=>{if(u.value===e.InteractionStatus.None){a.verbose("useMsal.logout():Called");const n={account:r.getActiveAccount()};if(s===e.InteractionType.Popup){const e=null!=t?t:{mainWindowRedirectUri:"/",...n};a.verbose(`useMsal.logout():logoutPopup triggered with ${JSON.stringify(e)}`),r.logoutPopup(e)}else if(s==e.InteractionType.Redirect){const e=null!=t?t:n;a.verbose(`useMsal.logout():logoutRedirect triggered with ${JSON.stringify(e)}`),r.logoutRedirect(e)}a.verbose("useMsal.logout():Returned")}else a.verbose(`useMsal.logout():Blocked due to other process is running (state=${u.value})`)}}}}exports.MsalPlugin=l,exports.createMsal=function(e){return new l(e)},exports.pkgBuildDate='"2023-12-15T09:17:55.510Z"',exports.pkgName=n,exports.pkgVersion=s,exports.useAccount=function(){const n=c(),s=n.options.interactionType,i=n.options.loginRequest,o=n.getLogger(),{account:a,instance:r}=u(),l=t.computed((()=>a.value?a.value.username:"(No username)")),g=t.computed((()=>null!=a.value&&null!=a.value.name?a.value.name:"(No name)"));return{account:a,name:g,username:l,switchAccount:async t=>{o.verbose("useAccount.switchAccount():Called");const n={...i,account:t,prompt:"none"};try{o.verbose(`useAccount.switchAccount():ssoClient triggered with: ${JSON.stringify(n)}`),await r.ssoSilent(n).then((e=>{o.verbose(`useAccount.switchAccount():ssoClient:success response: ${JSON.stringify(e)}`),null!=e.account&&(r.setActiveAccount(e.account),a.value=r.getActiveAccount(),o.info(`useAccount.switchAccount():ssoClient set ActiveAccount: ${e.account.username}`))}))}catch(t){if(o.verbose(`useAccount.switchAccount():ssoClient error: ${JSON.stringify(t)}`),t instanceof e.InteractionRequiredAuthError){const t={...n,prompt:"login"};s===e.InteractionType.Popup?r.loginPopup(t).then((e=>{o.verbose(`useAccount.switchAccount():loginPopup:success response: ${JSON.stringify(e)}`),null!=e.account&&(r.setActiveAccount(e.account),a.value=r.getActiveAccount(),o.info(`useAccount.switchAccount():loginPopup set ActiveAccount: ${e.account.username}`))})).catch((e=>{o.verbose(`useAccount.switchAccount():loginPopup error: ${JSON.stringify(e)}`)})):r.loginRedirect(t).catch((e=>{o.verbose(`useAccount.switchAccount():loginRedirect error: ${JSON.stringify(e)}`)}))}}o.verbose("useAccount.switchAccount():Returned")}}},exports.useIsAuthenticated=function(){const{accounts:e}=u(),n=t.ref(e.value.length>0);return t.watch(e,(()=>{n.value=e.value.length>0})),n},exports.useMsal=u,exports.useMsalAuthentication=function(){const n=c(),s=n.options.interactionType,i=n.options.loginRequest,o=n.getLogger(),{instance:a,inProgress:r}=u(),l=s,g=t.ref(!1),h=t.ref(null),v=t.ref(null);return{acquireToken:async t=>{if(o.verbose("useMsalAuthentication.acquireToken():Called"),!g.value){if(g.value=!0,r.value===e.InteractionStatus.HandleRedirect){o.verbose("useMsalAuthentication.acquireToken():handleRedirectPromise triggered");try{const e=await a.handleRedirectPromise();e&&(o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise success response: ${JSON.stringify(e)}`),h.value=e,v.value=null)}catch(e){o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise error: ${JSON.stringify(e)}`),h.value=null,v.value=e}g.value=!1}else if(r.value===e.InteractionStatus.None){const n=t||i;o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent triggered with ${JSON.stringify(n)}`);try{const e=await a.acquireTokenSilent(n);o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent success response: ${JSON.stringify(e)}`),h.value=e,v.value=null}catch(t){o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent error = ${JSON.stringify(t)}`),t instanceof e.InteractionRequiredAuthError||t instanceof e.BrowserAuthError&&t.errorCode===e.BrowserAuthErrorMessage.noAccountError.code&&0==a.getAllAccounts().length?(o.verbose(`useMsalAuthentication.acquireToken():interactive login triggered with ${JSON.stringify(n)}`),l===e.InteractionType.Popup?await a.loginPopup(n).then((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginPopup success response: ${JSON.stringify(e)}`),h.value=e,v.value=null})).catch((t=>{h.value=null,v.value=t,t instanceof e.BrowserAuthError&&t.errorCode===e.BrowserAuthErrorMessage.userCancelledError.code?o.info("useMsal.login():loginPopup user_cancelled"):o.error(`useMsal.login():loginPopup error: ${JSON.stringify(t)}`)})):await a.loginRedirect(n).catch((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginRedirect error: ${JSON.stringify(e)}`),h.value=null,v.value=e}))):(h.value=null,v.value=t)}}g.value=!1}o.verbose("useMsalAuthentication.acquireToken():Returned")},result:h,error:v}};
