/*!
 * vue-auth-msal v1.0.1
 * (c) 2023 Shige Fukushima <shigeyf@outlook.com>
 * @license Apache-2.0
 */
import{InteractionStatus as e,InteractionType as t,NavigationClient as n,PublicClientApplication as s,EventType as i,EventMessageUtils as o,BrowserAuthError as l,BrowserAuthErrorMessage as a,InteractionRequiredAuthError as c}from"@azure/msal-browser";import{reactive as r,inject as u,toRefs as g,ref as h,watch as v,computed as p}from"vue";const d="vue-auth-msal",A="1.0.1",b='"2023-12-15T09:17:50.516Z"',P=Symbol(),f=Symbol();function _(n,s){const i=s.getLogger();n.beforeEach((async(n,o)=>{i.verbose("vue-router:beforeEach():Called"),i.verbose("vue-router:beforeEach():Awaiting MsalPlugin Init"),await s.waitInitPromise,i.verbose("vue-router:beforeEach():Finished MsalPlugin Init");let l=!0;if(s.getCurrentInteractionStaus()===e.HandleRedirect){const e=n.fullPath.split("#")[0];n.fullPath=e,n.hash=""}if(n.matched.some((e=>e.meta.requiresAuth))){i.verbose("vue-router:beforeEach():Invoke RouterGuard for MsalPlugin because of 'requiresAuth' = true");const e={...s.options.loginRequest,redirectStartPage:n.fullPath};l=await async function(e,n,s){return e.handleRedirectPromise().then((()=>e.getAllAccounts().length>0||(n===t.Popup?e.loginPopup(s).then((()=>!0)).catch((()=>!1)):n===t.Redirect&&e.loginRedirect(s).then((()=>!0)).catch((()=>!1))))).catch((()=>!1))}(s.instance,s.options.interactionType,e)}return i.verbose("vue-router:beforeEach():Returned"),l}))}class C extends n{router;pca;constructor(e,t){super(),this.router=e,this.pca=t}async navigateInternal(e,t){this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Called"),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():url = ${e}`),this.pca.getLogger().verbose(`AuthNavigationClient:navigateInternal():options = ${JSON.stringify(t)}`);const n=e.replace(window.location.origin,"");return t.noHistory?this.router.replace(n):this.router.push(n),this.pca.getLogger().verbose("AuthNavigationClient:navigateInternal():Returned always false"),!1}}function R(e){return new S(e)}class S{instance;options;_state;_logger;_eventCallbacks;_initResolver;waitInitPromise;constructor(n){this.options={interactionType:t.Redirect,loginRequest:{scopes:[]}},this.instance=new s(n.configuration),null!=n.interactionType&&(this.options.interactionType=n.interactionType),null!=n.loginRequest&&(this.options.loginRequest=n.loginRequest),this._state=r({inProgress:e.None,activeAccount:this.instance.getActiveAccount(),accounts:this.instance.getAllAccounts()}),this._initResolver=null,this.waitInitPromise=Promise.resolve(),this.instance.initializeWrapperLibrary(d,A),this._logger=this.instance.getLogger().clone(d,A),this._eventCallbacks=[]}getLogger(){return this._logger}getCurrentInteractionStaus(){return this._state.inProgress}async install(e,n){if(this._logger.verbose("MsalPlugin:install():Called"),null!=n.router){this._logger.verbose("MsalPlugin:install:Initialize Router extension");const e=new C(n.router,this.instance);this.instance.setNavigationClient(e),_(n.router,this)}this._logger.verbose("MsalPlugin:install:Initialize MsalState"),e.provide(P,this),e.provide(f,this._state),this._logger.verbose("MsalPlugin:install:Initialize Event Callback Hooks");let s=null;s=this.instance.addEventCallback((e=>{this._logger.verbose(`MsalPlugin:install:EventCallback:[ForDebug]:EventType: ${e.eventType}`)})),this._eventCallbacks.push({name:"ForDebug",id:s}),s=this.instance.addEventCallback((e=>{if(e.eventType===i.LOGIN_SUCCESS){if(this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Called"),e.payload){const t=e.payload;this._logger.verbose(`MsalPlugin:install:EventCallback:[LoginSuccess]:Payload: ${JSON.stringify(t)}`),null!=t.account&&this.setNewActiveAccount(t.account)}this._logger.verbose("MsalPlugin:install:EventCallback:[LoginSuccess]:Returned")}})),this._eventCallbacks.push({name:"LoginSuccess",id:s}),s=this.instance.addEventCallback((e=>{switch(e.eventType){case i.LOGOUT_END:case i.ACCOUNT_ADDED:case i.ACCOUNT_REMOVED:case i.LOGIN_SUCCESS:case i.LOGIN_FAILURE:case i.SSO_SILENT_SUCCESS:case i.SSO_SILENT_FAILURE:case i.ACQUIRE_TOKEN_SUCCESS:case i.ACQUIRE_TOKEN_FAILURE:case i.HANDLE_REDIRECT_END:this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Called"),this.updateAccounts(),e.eventType===i.LOGOUT_END&&this.resetAccount(),this._logger.verbose("MsalPlugin:install:EventCallback:[AccountsUpdate]:Returned")}})),this._eventCallbacks.push({name:"AccountsUpdate",id:s}),s=this.instance.addEventCallback((e=>{this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Called"),this.updateStatusByMessage(e),this._logger.verbose("MsalPlugin:install:EventCallback:[StatusUpdate]:Returned")})),this._eventCallbacks.push({name:"StatusUpdate",id:s}),s=this.instance.addEventCallback((e=>{if(e.eventType===i.LOGOUT_END&&e.interactionType===t.Popup){this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Called");const e=n.router;if(null!=e){const t=e.currentRoute.value;t.meta.requiresAuth&&null!=t.meta.popupLogoutFallback&&(this._logger.info(`MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Route to: ${t.meta.popupLogoutFallback}`),e.push(t.meta.popupLogoutFallback))}this._logger.verbose("MsalPlugin:install:EventCallback:[LogOutPopupEnd]:Returned")}})),this._eventCallbacks.push({name:"LogOutPopupEnd",id:s}),this.waitInit(),await this.instance.initialize().then((()=>{this._logger.verbose("MsalPlugin:install:instance.initialize finished"),this.instance.handleRedirectPromise().then((e=>{null!=e?(this._logger.verbose(`MsalPlugin:install:handleRedirectPromise success response: ${JSON.stringify(e)}`),null!=e.account&&this.setNewActiveAccount(e.account)):(this._logger.verbose("MsalPlugin:install:handleRedirectPromise success response: null"),this.resetAccount(),this.updateAccounts())})).catch((e=>{this._logger.error(`MsalPlugin:install:handleRedirectPromise error: ${e}`)})).finally((()=>{this._logger.verbose("MsalPlugin:install:handleRedirectPromise:finally:Called"),this.resetInProgress()}))})),this.doneInit(),this._logger.verbose("MsalPlugin:install():Returned")}updateStatusByMessage(e){const t=this._state.inProgress,n=o.getInteractionStatusFromEvent(e,this._state.inProgress);null!==n&&(this._state.inProgress=n,this._logger.info(`MsalPlugin:updateStatusByMessage:Updated from ${t} to ${n}`))}resetInProgress(){this._state.inProgress=e.None,this._logger.info("MsalPlugin:resetInProgress: inProgress to none")}updateAccounts(){const e=this.instance.getAllAccounts();(function(e,t){if(e.length!==t.length)return!1;const n=[...t];return e.every((e=>{const t=n.shift();return!(!e||!t)&&e.homeAccountId===t.homeAccountId&&e.localAccountId===t.localAccountId&&e.username===t.username}))})(e,this._state.accounts)||(this._state.accounts=e,this._logger.info(`MsalPlugin:updateAccounts:Updated to: ${JSON.stringify(this._state.accounts)}`))}setNewActiveAccount(e){this.instance.setActiveAccount(e),this._state.activeAccount=this.instance.getActiveAccount(),this._logger.info(`MsalPlugin:setNewActiveAccount: ${e.username}`)}resetAccount(){const e=this.instance.getAllAccounts();if(0===e.length)this._state.activeAccount=null,this._logger.info("MsalPlugin:resetAccount: null");else if(e.length>0){const e=this._state.accounts[0];this.instance.setActiveAccount(e),this._state.activeAccount=e,this._logger.info(`MsalPlugin:resetAccount: ${e.username}`)}}waitInit(){null==this._initResolver&&(this.waitInitPromise=new Promise((e=>this._initResolver=e)))}doneInit(){null!=this._initResolver&&(this._initResolver(),this._initResolver=null,this.waitInitPromise=Promise.resolve())}}function y(){const e=u(P);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}function M(){const n=y(),s=n.options.interactionType,i=n.options.loginRequest,o=n.getLogger(),c=n.instance,r=function(){const e=u(f);if(null==e)throw"useMsal*() cannot be used without installing vue-auth-msal plugin.";return e}(),{inProgress:h,accounts:v,activeAccount:p}=g(r);return{instance:c,inProgress:h,account:p,accounts:v,ops:{login:n=>{if(h.value===e.None){o.verbose("useMsal.login():Called");const e=null!=n?n:i;s===t.Popup?(o.verbose(`useMsal.login():loginPopup triggered with ${JSON.stringify(e)}`),c.loginPopup(e).catch((e=>{e instanceof l&&e.errorCode===a.userCancelledError.code?o.info("useMsal.login():loginPopup user_cancelled"):o.error(`useMsal.login():loginPopup error: ${JSON.stringify(e)}`)}))):s==t.Redirect&&(o.verbose(`useMsal.login():loginRedirect triggered with ${JSON.stringify(e)}`),c.loginRedirect(e)),o.verbose("useMsal.login():Returned")}else o.verbose(`useMsal.login():Blocked due to other process is running (state=${h.value})`)},logout:n=>{if(h.value===e.None){o.verbose("useMsal.logout():Called");const e={account:c.getActiveAccount()};if(s===t.Popup){const t=null!=n?n:{mainWindowRedirectUri:"/",...e};o.verbose(`useMsal.logout():logoutPopup triggered with ${JSON.stringify(t)}`),c.logoutPopup(t)}else if(s==t.Redirect){const t=null!=n?n:e;o.verbose(`useMsal.logout():logoutRedirect triggered with ${JSON.stringify(t)}`),c.logoutRedirect(t)}o.verbose("useMsal.logout():Returned")}else o.verbose(`useMsal.logout():Blocked due to other process is running (state=${h.value})`)}}}}function m(){const{accounts:e}=M(),t=h(e.value.length>0);return v(e,(()=>{t.value=e.value.length>0})),t}function E(){const n=y(),s=n.options.interactionType,i=n.options.loginRequest,o=n.getLogger(),{instance:r,inProgress:u}=M(),g=s,v=h(!1),p=h(null),d=h(null);return{acquireToken:async n=>{if(o.verbose("useMsalAuthentication.acquireToken():Called"),!v.value){if(v.value=!0,u.value===e.HandleRedirect){o.verbose("useMsalAuthentication.acquireToken():handleRedirectPromise triggered");try{const e=await r.handleRedirectPromise();e&&(o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise success response: ${JSON.stringify(e)}`),p.value=e,d.value=null)}catch(e){o.verbose(`useMsalAuthentication.acquireToken():handleRedirectPromise error: ${JSON.stringify(e)}`),p.value=null,d.value=e}v.value=!1}else if(u.value===e.None){const e=n||i;o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent triggered with ${JSON.stringify(e)}`);try{const t=await r.acquireTokenSilent(e);o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent success response: ${JSON.stringify(t)}`),p.value=t,d.value=null}catch(n){o.verbose(`useMsalAuthentication.acquireToken():acquireTokenSilent error = ${JSON.stringify(n)}`),n instanceof c||n instanceof l&&n.errorCode===a.noAccountError.code&&0==r.getAllAccounts().length?(o.verbose(`useMsalAuthentication.acquireToken():interactive login triggered with ${JSON.stringify(e)}`),g===t.Popup?await r.loginPopup(e).then((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginPopup success response: ${JSON.stringify(e)}`),p.value=e,d.value=null})).catch((e=>{p.value=null,d.value=e,e instanceof l&&e.errorCode===a.userCancelledError.code?o.info("useMsal.login():loginPopup user_cancelled"):o.error(`useMsal.login():loginPopup error: ${JSON.stringify(e)}`)})):await r.loginRedirect(e).catch((e=>{o.verbose(`useMsalAuthentication.acquireToken():loginRedirect error: ${JSON.stringify(e)}`),p.value=null,d.value=e}))):(p.value=null,d.value=n)}}v.value=!1}o.verbose("useMsalAuthentication.acquireToken():Returned")},result:p,error:d}}function N(){const e=y(),n=e.options.interactionType,s=e.options.loginRequest,i=e.getLogger(),{account:o,instance:l}=M(),a=p((()=>o.value?o.value.username:"(No username)")),r=p((()=>null!=o.value&&null!=o.value.name?o.value.name:"(No name)"));return{account:o,name:r,username:a,switchAccount:async e=>{i.verbose("useAccount.switchAccount():Called");const a={...s,account:e,prompt:"none"};try{i.verbose(`useAccount.switchAccount():ssoClient triggered with: ${JSON.stringify(a)}`),await l.ssoSilent(a).then((e=>{i.verbose(`useAccount.switchAccount():ssoClient:success response: ${JSON.stringify(e)}`),null!=e.account&&(l.setActiveAccount(e.account),o.value=l.getActiveAccount(),i.info(`useAccount.switchAccount():ssoClient set ActiveAccount: ${e.account.username}`))}))}catch(e){if(i.verbose(`useAccount.switchAccount():ssoClient error: ${JSON.stringify(e)}`),e instanceof c){const e={...a,prompt:"login"};n===t.Popup?l.loginPopup(e).then((e=>{i.verbose(`useAccount.switchAccount():loginPopup:success response: ${JSON.stringify(e)}`),null!=e.account&&(l.setActiveAccount(e.account),o.value=l.getActiveAccount(),i.info(`useAccount.switchAccount():loginPopup set ActiveAccount: ${e.account.username}`))})).catch((e=>{i.verbose(`useAccount.switchAccount():loginPopup error: ${JSON.stringify(e)}`)})):l.loginRedirect(e).catch((e=>{i.verbose(`useAccount.switchAccount():loginRedirect error: ${JSON.stringify(e)}`)}))}}i.verbose("useAccount.switchAccount():Returned")}}}export{S as MsalPlugin,R as createMsal,b as pkgBuildDate,d as pkgName,A as pkgVersion,N as useAccount,m as useIsAuthenticated,M as useMsal,E as useMsalAuthentication};
